package gestionbd;
import java.sql.Connection; 
import java.sql.DriverManager; 
import java.sql.SQLException;
import java.sql.Statement;
import java.sql.ResultSet;
import java.util.*;
import gestionbd.AccionesSQLAltaClientes;
import gestionbd.AccionesSQLEditaClientes;
import gestionbd.AccionesSQLBorraClientes;
import clientes.vistas.PanelAltaClientes;
import clientes.vistas.PanelEditaClientes;
import clientes.vistas.PanelBorraClientes;
import clientes.vistas.PanelListaClientes;
import javax.swing.table.DefaultTableModel;

/**
 *
 * @author Juan
 */
public class GestionSQL {
    private final String DRIVER_JDBC = "com.mysql.jdbc.Driver";
    private final String DB_URL = "jdbc:mysql://localhost:3306/fastfood"; 
    private final String USER = "root"; 
    private final String PASS = "zoupas";
    private Connection conn;
    private PanelAltaClientes panelalta;
    private PanelEditaClientes paneledita;
    private PanelBorraClientes panelborra;
    private PanelListaClientes panellista;

    
    public GestionSQL(PanelAltaClientes panel) throws ClassNotFoundException{
        this.conn = null;
        this.panelalta = panel;
        
    }
    
    public GestionSQL(PanelEditaClientes panel) throws ClassNotFoundException{
        this.conn = null;
        this.paneledita = panel;
        
    }
    
     public GestionSQL(PanelBorraClientes panel) throws ClassNotFoundException{
        this.conn = null;
        this.panelborra = panel;
        
    }
     
    public GestionSQL(PanelListaClientes panel) throws ClassNotFoundException{
        this.conn = null;
        this.panellista = panel;
 
        
    } 
    
    
    
    public GestionSQL() throws ClassNotFoundException{
        this.conn = null;
    }
    
    public void openConnection() {
        try { //PASO 0: Registraríamos el driver con JDBC 3.0 
                Class.forName(this.DRIVER_JDBC);
            
              //PASO 1: Open a connection 
            System.out.println("Conectando con la BBDD..."); 
            this.conn = DriverManager.getConnection(this.DB_URL, this.USER, this.PASS); 
            System.out.println("Conexión extablecida OK..."); 
        } catch (SQLException se) { System.out.println("No se ha podido conectar con el Servidor"); 
        
        } catch (Exception e) {   System.out.println("Error ");     } 
        
    }
    
    public void closeConnection(){
        try { 
                if (this.conn != null) {
                    this.conn.close();
                }
            } catch (SQLException se) { System.out.println("Error al cerrar la conexión");  
            
        }System.out.println("Hasta pronto!");
    }
    
    public void executeSQL(String accion,String dni){
        
        switch(accion){
            case "guardar_alta":
                AccionesSQLAltaClientes sqlAltaClientes = new AccionesSQLAltaClientes(this.panelalta,this.conn);
                sqlAltaClientes.guardarCliente();
                break;
            case "llenarFormulario_editar":
                AccionesSQLEditaClientes sqlEditaClientes = new AccionesSQLEditaClientes(this.paneledita,this.conn);
                sqlEditaClientes.extraerCliente(true);
            case "guardarClienteEditado":
                AccionesSQLEditaClientes sqlEditaClientesGuardar = new AccionesSQLEditaClientes(this.paneledita,this.conn);
                sqlEditaClientesGuardar.guardarCliente();
            case "inicio_editar":    
                AccionesSQLEditaClientes sqlEditaClientesInicio = new AccionesSQLEditaClientes(this.paneledita,this.conn);
                sqlEditaClientesInicio.extraerCliente(true);
                break;
            case "avanzar_editar":
                AccionesSQLEditaClientes sqlEditaClientesAvanzar = new AccionesSQLEditaClientes(this.paneledita,this.conn);
                sqlEditaClientesAvanzar.avanzar(dni);
                break;
            case "retroceder_editar":
                AccionesSQLEditaClientes sqlEditaClientesRetroceder = new AccionesSQLEditaClientes(this.paneledita,this.conn);
                sqlEditaClientesRetroceder.retroceder(dni);
                break;
            case "final_editar":
                AccionesSQLEditaClientes sqlEditaClientesFinal = new AccionesSQLEditaClientes(this.paneledita,this.conn);
                sqlEditaClientesFinal.extraerCliente(false);
                break;
            case "llenarFormulario_borrar":
                AccionesSQLBorraClientes sqlBorraClientes = new AccionesSQLBorraClientes(this.panelborra,this.conn);
                sqlBorraClientes.extraerCliente(true);    
                break;
            case "eliminarCliente":
                AccionesSQLBorraClientes sqlBorraClientesEliminar = new AccionesSQLBorraClientes(this.panelborra,this.conn);
                sqlBorraClientesEliminar.borrarCliente(dni);
                break;
            case "inicio_borrar":
                AccionesSQLBorraClientes sqlBorraClientesInicio = new AccionesSQLBorraClientes(this.panelborra,this.conn);
                sqlBorraClientesInicio.extraerCliente(true);
                break;
            case "avanzar_borrar":
                AccionesSQLBorraClientes sqlBorraClientesAvanzar = new AccionesSQLBorraClientes(this.panelborra,this.conn);
                sqlBorraClientesAvanzar.avanzar(dni);
                break;
            case "retroceder_borrar":
                AccionesSQLBorraClientes sqlBorraClientesRetroceder = new AccionesSQLBorraClientes(this.panelborra,this.conn);
                sqlBorraClientesRetroceder.retroceder(dni);
                break;
            case "final_borrar":
                AccionesSQLBorraClientes sqlBorraClientesFinal = new AccionesSQLBorraClientes(this.panelborra,this.conn);
                sqlBorraClientesFinal.extraerCliente(false);
                break;
            case "llenar_tabla":
                AccionesSQLListaClientes sqlListaClientes = new AccionesSQLListaClientes(this.panellista,this.conn);
                sqlListaClientes.mostrarTabla();
                break;
                    
        }
    }
    
}
